/* $Id: CerdispP.h 1088 2006-06-06 11:15:49Z d $ */
/* David Leonard, 2001. Public domain. */

#ifndef _CerdispP_h
#define _CerdispP_h

#include "Cerdisp.h"

/* include superclass private header file */
#include <X11/CoreP.h>

#include "version.h"

typedef struct {
    XtPointer extension;		/* unused */
} CerdispClassPart;

typedef struct _CerdispClassRec {
    CoreClassPart	core_class;
    CerdispClassPart	cerdisp_class;
} CerdispClassRec;

extern CerdispClassRec cerdispClassRec;

struct lrulist;	/* Forward declaration */

#define MAXSOCK		5

typedef struct {
    /* resources */
    char *proxy;
    char *listen_port;
    char *proxy_port;
    Boolean print_version;
    Boolean verbose;
    int scale;

    /* private */
    int	connected;		/* 1 if connected */
    int	state, expected;	/* input state, and bytes expected */
    char *buf;
    int bufsz, bufpos;
    int serversock[MAXSOCK];	/* fdesc of server socket */
    int clientsock;		/* fdesc of active client socket or -1 */
    XtInputId clientinput;	/* input handle for client data */
    XtInputId serverinput[MAXSOCK]; /* input handle for new accepts */
    GC gc;
    XImage *image;
    int frame_width, frame_height;
    int framepos;		/* Pixel position of current frame */
    char peername[17];
    int proxysock;
    XtInputId proxyinput;
    struct lrulist *lru;	/* Least recently used colour list */
    int depth;			/* Depth of images received */
    struct palette_entry {
	    unsigned short red;
	    unsigned short green;
	    unsigned short blue;
    } *palette;
} CerdispPart;

typedef struct _CerdispRec {
    CorePart		core;
    CerdispPart		cerdisp;
} CerdispRec;

#endif /* _CerdispP_h */
