/* $Id: CerdispS.h 504 2003-08-26 05:50:48Z d $ */
/* David Leonard, 2002. Public domain. */

#ifndef _CerdispS_h
#define _CerdispS_h

/*
 * Structures used reading the CERDISP protocol
 */

struct preamble {
	CARD32	magic;
	CARD32	width;
	CARD32	height;
	CARD32	depth;
	CARD32	unk1;
	CARD32	unk2;
	char	platform[128];
	char	devtype[128];
	char	name[16];
	CARD32	unk3;
};

struct palettehdr {
	CARD32	type;		/* always 1? */
	CARD32	datalen;
};

struct palette {
	CARD8	red;		/* ? unsure */
	CARD8	green;		/* ? unsure */
	CARD8	blue;		/* ? unsure */
	CARD8	x;		/* ? unsure */
};

struct framehdr {
	CARD32	unk0;		/* always 0? */
	CARD32	datalen;
	CARD32	unk1;		/* x offset? */
	CARD32	unk2;		/* y offset? */
	CARD32	width;
	CARD32	height;
} framehdr;

struct rle {
	CARD16	repeat;
	union {
	    struct {
#if X_BYTE_ORDER == X_LITTLE_ENDIAN
		CARD16	blue : 5;
		CARD16	x : 1;
		CARD16	green : 5;
		CARD16	red : 5;
#else /* X_BIG_ENDIAN */
		CARD16	red : 5;
		CARD16	green : 5;
		CARD16	x : 1;
		CARD16	blue : 5;
#endif /* X_BIG_ENDIAN */
	    }		col;
	    struct {
#if X_BYTE_ORDER == X_LITTLE_ENDIAN
		CARD16	p1 : 4; /* palette index of second pixel */
		CARD16	p0 : 4; /* first pixel */
		CARD16	p3 : 4; /* fourth pixel */
		CARD16	p2 : 4; /* third pixel */
#else /* X_BIG_ENDIAN */
		CARD16	p2 : 4;
		CARD16	p3 : 4;
		CARD16	p0 : 4;
		CARD16	p1 : 4;
#endif /* X_BIG_ENDIAN */
	    }		col4;
	    CARD16	word;
	} u;
};

#define EVT_PTR_MOVE    0x0000
#define EVT_PTR_DOWN    0x0002
#define EVT_PTR_UP      0x0004
#define EVT_KEY_DOWN    0x0100
#define EVT_KEY_UP      0x0101

#endif /* _CerdispS_h */
